package com.ruoyi.gysl.regular;

import cn.hutool.core.util.CreditCodeUtil;
import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.docking.entity.SmartDeclaration;
import com.ruoyi.docking.entity.SmartReminders;
import com.ruoyi.docking.service.ProjectProgressService;
import com.ruoyi.docking.service.ProjectService;
import com.ruoyi.docking.service.SmartDeclarationService;
import com.ruoyi.docking.service.SmartRemindersService;
import com.ruoyi.gysl.entity.BasicInformation;
import com.ruoyi.gysl.service.BasicInformationService;
import com.ruoyi.gysl.service.NoticeService;
import com.ruoyi.system.mapper.SysUserMapper;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 每月固定时间定时任务
 * @author du
 * @since 2025/3/23 16:35
 */
//@Configuration
//@EnableScheduling
    @Component
public class NoticeTiming {

    @Resource
    private NoticeService noticeService;

    @Resource
    private ProjectProgressService projectProgressService;

    @Resource
    private ProjectService projectService;

    @Resource
    private SmartRemindersService smartRemindersService;

    @Resource
    private SmartDeclarationService smartDeclarationService;

    @Resource
    private BasicInformationService basicInformationService;

    /**
     * 人员
     */
    @Resource
    private SysUserMapper sysUserMapper;
    /**
     * 每个月固定发一次政务通知
     */
//    @Scheduled(cron = "0 0 0 1 * ?")
//    private void configureTasks() {
//        Notice notice = new Notice();
//        notice.setType(1);
//        notice.setContent(LocalDate.now().getYear() +
//                "年"+
//                LocalDate.now().getMonth().getValue()+
//                "月"+
//                "项目进展未填写");
//        noticeService.save(notice);
//    }

    /**
     * 每个月1号的2点进行上个月的项目月度信息查询并进行新增
     */
//    @Scheduled(cron = "0 0 2 1 * ?")  // 每月1号 2:00:00 执行
//    private void changeProgress() {
//        List<ProjectProgress> pList = projectProgressService.djList();
//        //修改该progressId为空
//        pList.forEach(x-> x.setProgressId(null));
//        //批量新增
//        projectProgressService.saveBatch(pList);
//
//        List<Project> pjList = projectService.djList();
//        projectService.saveBatch(pjList);
//    }
    /**
     * 定时不定期提醒
     */
//    @Scheduled(cron = "0 40 1 * * *")
    public void changeNdq() {
        //获取企业的不定时提醒
        SmartReminders qy = smartRemindersService.getById(1);
        //获取政务的不定时提醒
        SmartReminders zw = smartRemindersService.getById(2);
        List<SmartDeclaration> smdList =new ArrayList<>();
        //获取所有的项目
        List<BasicInformation> list = basicInformationService.list();
        List<BasicInformation> list1 = basicInformationService.list();
        //如果当前时间在该项目的结束时间前自定义的提前天数之前，就去掉
        list.removeIf(x ->
                !(LocalDate.now().equals(x.getEndTime().minusDays(qy.getDaysAdvance())))
        );
        list.forEach(x->{
            SmartDeclaration smartDeclaration = new SmartDeclaration();
            smartDeclaration.setSmartRemindersId(1L);
            smartDeclaration.setTyshxydm(x.getTyshxydm());
            smartDeclaration.setAlertTime(x.getEndTime().atStartOfDay());
            smdList.add(smartDeclaration);
        });
        list1.removeIf(x ->
                !(LocalDate.now().equals(x.getEndTime().minusDays(zw.getDaysAdvance())))
        );
        //获取到所有的符合条件的政务用户

        List<SysUser> sysUsers = sysUserMapper.selectUserList(new SysUser());
        List<SysUser> collect = sysUsers.stream().filter(x -> "0".equals(x.getDelFlag()) && "0".equals(x.getStatus()))
                .filter(y -> !CreditCodeUtil.isCreditCode(y.getUserName()))
                .collect(Collectors.toList());
        list1.forEach(x->{
            for (SysUser y : collect) {
                SmartDeclaration sd = new SmartDeclaration();
                sd.setAlertTime(x.getEndTime().atStartOfDay());
                sd.setSmartRemindersId(2L);
                sd.setZwId(y.getUserId());
                smdList.add(sd);
            }
        });
        smartDeclarationService.saveBatch(smdList);
    }
}
